#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "gettext.c"

// Vorbereitung der Sprachdateien

void updatetext(char *orig, char *trans){
	char st1[20480];
	transRec *act;
	char *cp;
	cp=trans;
	while(cp=strstr(cp,"\\n")){
		strcpy(st1,cp+2);
		strcpy(cp,"\n");
		cp++;
		strcpy(cp,st1);
	}
	//printf("add %s -> %s\n",orig,trans);
	if(strlen(orig)){
		act=transRoot;
		while(act){
			if(!strcmp(act->orig,orig)){
				free(act->trans);
				act->trans=(char*)malloc(strlen(trans)+1);
				strcpy(act->trans,trans);
				return;
			}
			act=act->next;
		}
		return;
	}
}

void updatetextfile(const char *filename){
	char st1[2048],orig[2048],trans[2048],*cp,*dp,dest;
	FILE *f;
	if(!strlen(filename)) return;
	f=fopen(filename,"r");
	if(!f) return;
	while(fgets(st1,2020,f)){
		if(cp=strchr(st1,'\n')) *cp=0;
		if(cp=strrchr(st1,'"')) *cp=0;

		cp=st1;
		if(!strncmp(st1,"msgid",5)){
			orig[0]=0;
			dest=0;
			cp=st1+6;
			strcpy(orig,cp+1);
		}


		if(!strncmp(st1,"msgstr",6)){
			trans[0]=0;
			dest=1;
			cp=st1+7;
		}

	if(dest){
		if(*cp=='"') strcat(trans,cp+1);
	}

	if(!strlen(st1)) updatetext(orig,trans);
	}
	fclose(f);
	updatetext(orig,trans);
}

void writetextfile(const char* name){
	FILE *f;
	transRec *act;
	f=fopen(name,"w");
	if(!f) return;
	act=transRoot;
	while(act){
		fprintf(f,"\n%s\nmsgid \"%s\"\nmsgstr \"%s\"\n",act->remark,act->orig,act->trans);
		act=act->next;
	}
	fclose(f);
	return;
}

int main(int argc, char** argv){
	int c;
	for(c=1;c<argc;c++){
		printf("Bearbeite %s\n",argv[c]);
		loadtextfile("lang/csvplot.pot");
		updatetextfile(argv[c]);
		writetextfile(argv[c]);
		purgetext();
	}
	return(0);
}
